## dwarfutils 20200114

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(libdwarf C CXX)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include_directories( ${CMAKE_BINARY_DIR} )

# used to compile on MSVC upto 2013 where snprintf is not available
macro(msvc_posix target)
    if(MSVC AND ("${MSVC_VERSION}" LESS 1900))
        # under VS 2015
	target_compile_definitions(${target} PUBLIC 
	    snprintf=_snprintf)
    endif()
endmacro()

# set target folder on IDE
macro(set_folder target folder)
  set_target_properties(${target} PROPERTIES FOLDER ${folder})
endmacro()

# set source groups on IDE
macro(set_source_group list_name group_name)
    set(${list_name} ${ARGN})
    source_group(${group_name} FILES ${ARGN})
endmacro()

# view folders on supported IDEs
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# used when finding libelf
# tells cmake to look in 64bit first (cmake
# would probably do this anyway).
set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)

enable_testing()

# always include project's folder to includes
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE ON)

### begin what was configure.cmake
# cmake macros
include(TestBigEndian)
include(CheckIncludeFile)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckSymbolExists)

set(VERSION 20191022)
set(PACKAGE_VERSION "\"${VERSION}\"") 
set(PACKAGE_NAME "libdwarf" )
###set(VERSION ${PACKAGE_VERSION} )
set(PACKAGE_STRING "\"${PACKAGE_NAME} ${VERSION}\"")
string(REGEX REPLACE "[\"]" "" tarname1 "${PACKAGE_STRING}" )
string(REGEX REPLACE "[^a-zA-Z0-9_]" "-" tarname "${tarname1}" )
set(PACKAGE_TARNAME "\"${tarname}\"" )
###set(PACKAGE_VERSION  "\"${PACKAGE_VERSION}\"")

test_big_endian(isBigEndian)
if (${isBigEndian})
  set ( WORDS_BIGENDIAN 1 )
endif()

check_include_file( "sys/types.h"     HAVE_SYS_TYPES_H) 
check_include_file( "sys/stat.h"      HAVE_SYS_STAT_H ) 
check_include_file( "stdlib.h"        HAVE_STDLIB_H   ) 
check_include_file( "string.h"        HAVE_STRING_H   ) 
check_include_file( "memory.h"        HAVE_MEMORY_H   ) 
check_include_file( "strings.h"       HAVE_STRINGS_H  ) 
check_include_file( "stdint.h"        HAVE_STDINT_H   )
check_include_file( "unistd.h"        HAVE_UNISTD_H   )
check_include_file( "sgidefs.h"       HAVE_SGIDEFS_H  )
check_include_file( "stdafx.h"        HAVE_STDAFX_H   )
check_include_file( "Windows.h"       HAVE_WINDOWS_H  )
check_include_file( "elf.h"           HAVE_ELF_H      ) 
check_include_file( "libelf.h"        HAVE_LIBELF_H   ) 
check_include_file( "libelf/libelf.h" HAVE_LIBELF_LIBELF_H) 
check_include_file( "alloca.h"        HAVE_ALLOCA_H   )
check_include_file( "elfaccess.h"     HAVE_ELFACCESS_H)
check_include_file( "sys/elf_386.h"   HAVE_SYS_ELF_386_H  )
check_include_file( "sys/elf_amd64.h" HAVE_SYS_ELF_AMD64_H)
check_include_file( "sys/elf_sparc.h" HAVE_SYS_ELF_SPARC_H)
check_include_file( "sys/ia64/elf.h"  HAVE_SYS_IA64_ELF_H )

if(HAVE_STDINT_H)
  check_c_source_compiles("
  #include <stdint.h>
  int main()
  {
      uintptr_t i; i = 12;
      return (int)i;
  }" HAVE_UINTPTR_T)
  check_c_source_compiles("
  #include <stdint.h>
  int main()
  {
      intptr_t i; i = 12;
      return (int)i;
  }" HAVE_INTPTR_T)
endif()
if (HAVE_UINTPTR_T)
  message(STATUS "HAVE_UINTPTR_T 1: uintptr_t defined in stdint.h... YES")
else()
  message(STATUS "uintptr_t defined in stdint.h... NO")
  set(uintptr_t "unsigned long long int" )
  message(STATUS "Setting #define uintptr_t " ${uintptr_t})
endif()
if (uintptr_t) 
  message(STATUS "uintptr_t value considered YES ")
else()
  message(STATUS "uintptr_t value considered NO ")
endif()
if (HAVE_INTPTR_T)
  message(STATUS "HAVE_INTPTR_T 1: intptr_t defined in stdint.h... YES")
else()
  message(STATUS "intptr_t defined in stdint.h... NO")
  set(uintptr_t "long long int" )
  message(STATUS "Setting #define intptr_t " ${intptr_t})
endif()
if (intptr_t) 
  message(STATUS "intptr_t value considered YES ")
else()
  message(STATUS "intptr_t value considered NO ")
endif()


#  It's not really setting the location of libelfheader, 
#  it is really #  either elf.h, or if that is missing 
#  it is assuming  elf.h data is in the supplied libelf.

if(HAVE_ELF_H)
    set(HAVE_LOCATION_OF_LIBELFHEADER "<elf.h>")
elseif(HAVE_LIBELF_H)
    set(HAVE_LOCATION_OF_LIBELFHEADER "<libelf.h>")
elseif(HAVE_LIBELF_LIBELF_H)
    set(HAVE_LOCATION_OF_LIBELFHEADER "<libelf/libelf.h>")
endif()

if(HAVE_LIBELF_H)
    set(JUST_LIBELF "<libelf.h>")
    set(PLAIN_JUST_LIBELF "libelf.h")
elseif(HAVE_LIBELF_LIBELF_H)
    set(JUST_LIBELF "<libelf/libelf.h>")
    set(PLAIN_JUST_LIBELF "libelf/libelf.h")
endif()

if (HAVE_LIBELF_H OR HAVE_LIBELF_LIBELF_H)
  set (CMAKE_REQUIRED_LIBRARIES elf)
  message(STATUS "libelf header ${PLAIN_JUST_LIBELF} checking for elf64_getehdr")
  check_symbol_exists( elf64_getehdr ${PLAIN_JUST_LIBELF} HAVE_ELF64_GETEHDR)
  message(STATUS "libelf header ${PLAIN_JUST_LIBELF} checking for elf64_getshdr")
  check_symbol_exists( elf64_getshdr ${PLAIN_JUST_LIBELF} HAVE_ELF64_GETSHDR)
  set (CMAKE_REQUIRED_LIBRARIES)
endif()

option(DWARF_WITH_LIBELF "Use libelf (default is YES)" TRUE)
message(STATUS "Building using libelf... ${DWARF_WITH_LIBELF}")
if (DWARF_WITH_LIBELF AND 
    NOT HAVE_LIBELF_H AND 
    NOT HAVE_LIBELF_LIBELF_H)
    set(DWARF_WITH_LIBELF OFF)
endif ()

if (DWARF_WITH_LIBELF)
  message(STATUS "checking using HAVE_ELF_H ... ${HAVE_ELF_H}")
  message(STATUS "checking using elf header ... ${HAVE_LOCATION_OF_LIBELFHEADER}")
  message(STATUS "checking using libelf header ... ${JUST_LIBELF}")
  check_c_source_compiles("
  #include ${HAVE_LOCATION_OF_LIBELFHEADER}
  int main()      
  {
      Elf64_Rel *p; int i; i = p->r_info;
      return 0;
  }" HAVE_ELF64_R_INFO)

  check_c_source_compiles("
  #include  ${HAVE_LOCATION_OF_LIBELFHEADER}
  int main()
  {
      Elf64_Rela p; p.r_offset = 1;
      return 0;
  }" HAVE_ELF64_RELA)
    
  check_c_source_compiles("
  #include ${HAVE_LOCATION_OF_LIBELFHEADER}
  int main()
  {
      Elf64_Sym p; p.st_info = 1;
      return 0;
  }" HAVE_ELF64_SYM)
  check_c_source_compiles("
  #include ${HAVE_LOCATION_OF_LIBELFHEADER}
  int main()
  {
      int p; p = 0;
      return 0;
  }" HAVE_RAW_LIBELF_OK)

  # This is attempting do determine that with GNU_SOURCE
  # we have off64_t. The autoconf version is not attemping
  # to set HAVE_LIBELF_OFF64_OK at present. 
  check_c_source_compiles("
  #define _GNU_SOURCE 1
  #include ${JUST_LIBELF}
  int main()
  { 
      off64_t  p; p = 0;
      return 0;
  }"  HAVE_LIBELF_OFF64_OK)

  check_c_source_compiles("
  #include ${JUST_LIBELF}
  /* This must be at global scope */
  struct _Elf;
  typedef struct _Elf Elf;
  struct _Elf *a = 0;
  int main()
  {
   int i = 12;
   return 0;
  }" HAVE_STRUCT_UNDERSCORE_ELF)
endif()
message(STATUS "Assuming struct Elf for the default libdwarf.h")
# Because cmake treats ; in an interesting way attempting
# to read/update/write Elf to _Elf fails badly: semicolons vanish.
# So for _Elf use a pre-prepared version.
if(HAVE_STRUCT_UNDERSCORE_ELF AND DWARF_WITH_LIBELF)
   message(STATUS "Found struct _Elf in ${JUST_LIBELF}")
   message(STATUS "Using struct _Elf in libdwarf.h")
   configure_file(libdwarf/generated_libdwarf.h.in 
       libdwarf/libdwarf.h COPYONLY)
else()
   configure_file(libdwarf/libdwarf.h.in 
       libdwarf/libdwarf.h COPYONLY)
   message(STATUS "${JUST_LIBELF} does not have struct _Elf")
   message(STATUS "Using struct Elf in libdwarf.h")
endif()

check_c_source_runs("
  static unsigned foo( unsigned x, 
      __attribute__ ((unused)) int y)
  {  
      unsigned x2 = x + 1;
      return x2;
  } 
  
  int main(void) {
      unsigned y = 0;
      y = foo(12,y);
      return 0;
  }"    HAVE_UNUSED_ATTRIBUTE)
message(STATUS "Checking compiler supports __attribute__ unused... ${HAVE_UNUSED_ATTRIBUTE}")

#  checking for ia 64 types, which might be enums, 
#  using HAVE_R_IA_64_DIR32LSB
#  to stand in for a small set.
check_c_source_compiles("
  #include ${HAVE_LOCATION_OF_LIBELFHEADER}
  int main()
  {  
      int p; p = R_IA_64_DIR32LSB;
      return 0;
  }" HAVE_R_IA_64_DIR32LSB)

check_c_source_compiles([=[
  #include "stdafx.h"
  int main() 
  { 
      int p; p = 27;
      return 0;
  }]=] HAVE_STDAFX_H)
#message(STATUS "Checking have windows stdafx.h... ${HAVE_STDAFX_H}")

check_c_source_compiles([=[
  #include <sys/types.h>
  #include <regex.h> 
  int main()
  {
      int i; 
      regex_t r;
      int cflags = REG_EXTENDED;
      const char *s = "abc";
      i = regcomp(&r,s,cflags);
      regfree(&r);
      return 0;
  } ]=]  HAVE_REGEX)

set(CMAKE_REQUIRED_LIBRARIES z)
check_c_source_compiles( [=[
  #include "zlib.h"
  int main()
  {
      Bytef dest[100];
      uLongf destlen = 100;
      Bytef *src = 0;
      uLong srclen = 3;
      int res = uncompress(dest,&destlen,src,srclen);
      if (res == Z_OK) {
           /* ALL IS WELL */
      }
      return 0;
  } ]=]  HAVE_ZLIB )
set(CMAKE_REQUIRED_LIBRARIES)
if (HAVE_ZLIB) 
  # For linking in libz
  set(DW_FZLIB "z")
endif()

check_c_source_compiles([=[
#include <stdint.h>
int main()
{
    intptr_t p; 
    p = 27;
    return 0;
}]=] HAVE_INTPTR_T)

message(STATUS "CMAKE_SIZEOF_VOID_P ... " ${CMAKE_SIZEOF_VOID_P} )

# libdwarf default-disabled shared
option(BUILD_SHARED "build shared library libdwarf.so and use it if present" FALSE)
option(BUILD_NON_SHARED "build archive library libdwarf.a" TRUE)

#  This adds compiler option -Wall (gcc compiler warnings)
option(WALL "Add -Wall" FALSE)

#  DW_FWALLXX are gnu C++ options.
if (WALL)
  set(DW_FWALLXX -Wall -Wextra -Wno-unused-private-field -Wpointer-arith -Wmissing-declarations -Wcomment -Wformat -Wpedantic -Wuninitialized -Wshadow -Wno-long-long -Werror)
  set(DW_FWALL ${DW_FWALLXX} -Wpointer-arith -Wmissing-declarations -Wmissing-prototypes -Wdeclaration-after-statement -Wextra -Wcomment -Wformat -Wpedantic -Wuninitialized -Wno-long-long -Wshadow -Werror )
  message(STATUS "Compiler warning options... YES ${DW_FWALL}")
else()
  unset(DW_FWALL )
  message(STATUS "Compiler warning options... NO")
endif()

option(HAVE_CUSTOM_LIBELF "Have a custom libelf library (default is NO)" FALSE)
message(STATUS "Including a custom libelf library... ${HAVE_CUSTOM_LIBELF}")

option(HAVE_NONSTANDARD_PRINTF_64_FORMAT "Use a special printf format for 64bit (default is NO)" FALSE)
message(STATUS "Checking enable non standard printf... ${HAVE_NONSTANDARD_PRINTF_64_FORMAT}")

option(BUILD_DWARFGEN "Build dwarfgen (default is NO)" FALSE)
message(STATUS "Building dwarfgen    ... ${BUILD_DWARFGEN}")

option(BUILD_DWARFEXAMPLE "Build dwarfexample (default is NO)" FALSE)
message(STATUS "Building dwarfexample... ${BUILD_DWARFEXAMPLE}")

option(DO_TESTING "Do certain api tests (default is NO)" FALSE)
message(STATUS "Building api tests   ... ${DOTESTS}")
### end what was configure.cmake

#  This changes the gennames option from -s  to -t
#  though in  2019 builds we no longer run gennames.
option(NAMES_TABLE "string functions implemented as binary search (default is with C switch)" TRUE)
if(NAMES_TABLE)
    set(dwarf_namestable "-s")
else()
    set(dwarf_namestable "-t")
endif()
    
option(HAVE_WINDOWS_PATH "Detect certain Windows paths as full paths (default is NO)" FALSE)
message(STATUS "Checking enable windows path... ${HAVE_WINDOWS_PATH}")
    
option(HAVE_OLD_FRAME_CFA_COL "Use HAVE_OLD_FRAME_CFA_COL (default is to use new DW_FRAME_CFA_COL3)" FALSE)
message(STATUS "Checking enable old frame columns... ${HAVE_OLD_FRAME_CFA_COL}")

#  See pro_init(), HAVE_DWARF2_99_EXTENSION also generates
#  32bit offset dwarf unless DW_DLC_OFFSET_SIZE_64 flag passed to
#  pro_init.
option(HAVE_SGI_IRIX_OFFSETS "Force producer to SGI IRIX offset dwarf" FALSE)
message(STATUS "Checking  producer generates SGI IRIX output... ${HAVE_SGI_IRIX_OFFSETS}")

option(HAVE_STRICT_DWARF2_32BIT_OFFSET "Force producer to generate only DWARF format 32bit" FALSE)

=== dwarfexample/CMakeLists.txt ===
set_source_group(SIMPLE_READER_SOURCES "Source Files" simplereader.c)

set_source_group(CONFIGURATION_FILES "Configuration Files"
  ${CMAKE_SOURCE_DIR}/config.h.in.cmake
  ${CMAKE_BINARY_DIR}/config.h)

add_executable(simplereader 
   ${SIMPLE_READER_SOURCES} 
   ${SIMPLE_READER_HEADERS} 
   ${CONFIGURATION_FILES})
set_folder(simplereader dwarfexample)
target_compile_definitions(simplereader PRIVATE CONFPREFIX={CMAKE_INSTALL_PREFIX}/lib)
target_compile_options(simplereader PRIVATE ${DW_FWALL})
target_link_libraries(simplereader PRIVATE ${dwarf-target} ${DW_FZLIB})

set_source_group(FRAME1_SOURCES "Source Files" frame1.c)
add_executable(frame1 ${FRAME1_SOURCES} ${FRAME1_HEADERS} ${CONFIGURATION_FILES})
set_folder(frame1 dwarfexample)
target_compile_definitions(frame1 PRIVATE CONFPREFIX={CMAKE_INSTALL_PREFIX}/lib)
target_compile_options(frame1 PRIVATE ${DW_FWALL})
target_link_libraries(frame1 PRIVATE ${dwarf-target} ${DW_FZLIB})

set_source_group(FINDFUNCBYPC_SOURCES "Source Files" findfuncbypc.c)
add_executable(findfuncbypc ${FINDFUNCBYPC_SOURCES} ${FINDFUNCBYPC_HEADERS} ${CONFIGURATION_FILES})
set_folder(findfuncbypc dwarfexample)
target_compile_definitions(findfuncbypc PRIVATE CONFPREFIX={CMAKE_INSTALL_PREFIX}/lib)
target_compile_options(findfuncbypc PRIVATE ${DW_FWALL})
target_link_libraries(findfuncbypc PRIVATE ${dwarf-target} ${DW_FZLIB})

=== debian/control ===
Source: dwarfutils
Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 12),
               libelf-dev,
               zlib1g-dev
Standards-Version: 4.5.0
Homepage: https://www.prevanders.net/dwarf.html
Vcs-Git: https://salsa.debian.org/wolff-guest/dwarfutils.git/
Vcs-Browser: https://salsa.debian.org/wolff-guest/dwarfutils

Package: dwarfdump
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: utility to dump DWARF debug information from ELF objects
 Dwarfdump is an application that can print the DWARF debugging
 information of an ELF object file in a human-readable form. It can
 also be used to check and validate manipulated DWARF sections.
 .
 This utility is part of dwarfutils.

Package: libdwarf-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdwarf1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: library to consume and produce DWARF debug information
 The libdwarf package provides a library which allows
 reading/consuming and writing/producing of DWARF debugging
 information from object files, shared libraries, and executables.
 .
 This package contains developer resources for libdwarf. Install it if
 you want to develop software that uses the libdwarf API.
 .
 This library is part of dwarfutils.

Package: libdwarf1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: library to consume and produce DWARF debug information (runtime)
 The libdwarf package provides a library which allows
 reading/consuming and writing/producing of DWARF debugging
 information from object files, shared libraries, and executables.
 .
 This package contains the runtime library. You should not have to
 install it manually.

## dwarfutils 20200825

=== dwarfdump/CMakeLists.txt ===

set_source_group(SOURCES "Source Files" addrmap.c 
    checkutil.c dwarfdump.c dwconf.c helpertree.c 
	glflags.c command_options.c compiler_info.c
    dwarf_names.c
	macrocheck.c print_abbrevs.c print_aranges.c
    print_debugfission.c print_die.c 
    print_debug_gnu.c
	print_debug_names.c  print_debug_sup.c
    print_frames.c  print_gdbindex.c
    print_hipc_lopc_attr.c
	print_lines.c 
    print_llex_codes.c print_origloclist_codes.c 
    print_loclists_codes.c
    print_locs.c  print_loclists.c
    print_macro.c print_macros.c 
    print_pubnames.c print_ranges.c 
    print_rnglists.c print_reloc.c 
	print_str_offsets.c
	print_sections.c  print_section_groups.c print_static_funcs.c
    print_static_vars.c print_strings.c print_types.c 
    print_weaknames.c  
	sanitized.c section_bitmaps.c strstrnocase.c 
    true_section_name.c uri.c dwgetopt.c makename.c 
    naming.c common.c esb.c dwarf_tsearchbal.c)
	
set_source_group(HEADERS "Header Files" 
  addrmap.h checkutil.h common.h dwconf.h
  command_options.h compiler_info.h
  dwarf_names.h
  print_debug_gnu.h
  dwconf_using_functions.h esb_using_functions.h
  dwarfdump-ta-ext-table.h dwarfdump-ta-table.h 
  dwarfdump-tt-ext-table.h dwarfdump-tt-table.h
  dwgetopt.h esb.h glflags.h globals.h macrocheck.h defined_types.h
  makename.h dwarf_tsearch.h print_frames.h 
  print_reloc.h print_reloc_decls.h section_bitmaps.h uri.h)

set_source_group(CONFIGURATION_FILES "Configuration Files"
  ${CMAKE_SOURCE_DIR}/config.h.in.cmake
  ${CMAKE_BINARY_DIR}/config.h)
	
add_executable(dwarfdump ${SOURCES} ${HEADERS} ${CONFIGURATION_FILES})

set_folder(dwarfdump dwarfdump)


target_compile_definitions(dwarfdump PRIVATE 
    "CONFPREFIX=${CMAKE_INSTALL_PREFIX}/lib")
target_compile_options(dwarfdump PRIVATE ${DW_FWALL})

target_link_libraries(dwarfdump PRIVATE ${dwarf-target} ${DW_FZLIB}) 

# Plain GNU C dash E does not work on a .list, 
# so copy to a .c name to run
# the following four table creations.
set(SELFTEST "-DSELFTEST")
	
if (DO_TESTING) 
    set_source_group(GETOPTEST_SOURCES "Source Files" 
      getopttest.c dwgetopt.c)
    add_executable(selfgetopttest ${GETOPTEST_SOURCES})
    target_compile_options(selfgetopttest PRIVATE ${DW_FWALL})
    add_test(NAME selfgetopttest COMMAND selfgetopttest)
endif()    
    
if (DO_TESTING) 
    set_source_group(TESTESB_SOURCES "Source Files" esb.c testesb.c
       dwarf_tsearchbal.c)
    add_executable(selftestesb ${TESTESB_SOURCES})
    target_compile_options(selftestesb PRIVATE ${SELFTEST} )
    target_compile_options(selftestesb PRIVATE ${DW_FWALL})
    add_test(NAME selftestesb COMMAND selftestesb)
endif()

if (DO_TESTING) 
    set_source_group(TESTESB_SOURCES "Source Files" getopttest.c
        dwgetopt.c)
    add_executable(selfgetopttestnat ${GETOPTEST_SOURCES})
    target_compile_options(selfgetopttestnat PRIVATE ${DW_FWALL})
    if(UNIX)
	    target_compile_definitions(selfgetopttestnat 
            PRIVATE GETOPT_FROM_SYSTEM)
    endif()
    foreach(i 1 2 3 5 6 7 8 9 10)
	    add_test(NAME selfgetopttestnat${i} 
                COMMAND selfgetopttestnat -c ${i})
    endforeach()
endif()

if (DO_TESTING) 
    set_source_group(MAKENAME_SOURCES "Source Files"
       makename_test.c esb.c dwarf_tsearchbal.c makename.c)
    add_executable(selfmakename ${MAKENAME_SOURCES})
    target_compile_options(selfmakename PRIVATE ${DW_FWALL})
    target_compile_options(selfmakename PRIVATE 
        "-I${CMAKE_SOURCE_DIR}/libdwarf")
    target_compile_options(selfmakename PRIVATE 
        "-I${CMAKE_BINARY_DIR}/libdwarf")
    add_test(NAME selfmakename COMMAND selfmakename)
endif()


if (DO_TESTING) 
    set_source_group(HELPERTREE_SOURCES "Source Files"
       helpertree_test.c helpertree.c dwarf_tsearchbal.c)
    add_executable(selfhelpertree ${HELPERTREE_SOURCES})
    target_compile_options(selfhelpertree PRIVATE ${DW_FWALL})
    target_compile_options(selfhelpertree PRIVATE 
        "-I${CMAKE_SOURCE_DIR}/dwarfdump")
    target_compile_options(selfhelpertree PRIVATE 
        "-I${CMAKE_SOURCE_DIR}/libdwarf")
    target_compile_options(selfhelpertree PRIVATE 
        "-I${CMAKE_BINARY_DIR}/libdwarf")
    add_test(NAME selfhelpertree COMMAND selfhelpertree)
endif()

if (DO_TESTING) 
    set_source_group(SELFMC_SOURCES "Source Files" macrocheck.c
        esb.c dwarf_tsearchbal.c)
    add_executable(selfmc ${SELFMC_SOURCES} )
    target_compile_options(selfmc PRIVATE ${SELFTEST} )
    target_compile_options(selfmc PRIVATE ${DW_FWALL})
    target_compile_options(selfmc PRIVATE 
        "-I${CMAKE_SOURCE_DIR}/libdwarf")
    target_compile_options(selfmc PRIVATE 
        "-I${CMAKE_BINARY_DIR}/libdwarf")
    add_test(NAME selfmc COMMAND selfmc)
endif()

if (DO_TESTING) 
    set_source_group(SELFESB_SOURCES "Source Files"
        testesb.c esb.c)
    add_executable(selfesb ${SELFESB_SOURCES})
    target_compile_options(selfesb PRIVATE ${SELFTEST} )
    target_compile_options(selfesb PRIVATE ${DW_FWALL})
    target_compile_options(selfmakename PRIVATE 
        "-I${CMAKE_SOURCE_DIR}/libdwarf")
    target_compile_options(selfmakename PRIVATE 
        "-I${CMAKE_BINARY_DIR}/libdwarf")
    add_test(NAME selfesb COMMAND selfesb)
endif()

if (DO_TESTING) 
    set_source_group(SECTIONBITMAPS_SOURCES "Source Files" 
        section_bitmaps.c section_bitmaps_test.c )
    add_executable(selfsectionbitmaps ${SECTIONBITMAPS_SOURCES})
    target_compile_options(selfsectionbitmaps PRIVATE 
        ${SELFTEST} )
    target_compile_options(selfsectionbitmaps PRIVATE ${DW_FWALL})
    target_compile_options(selfsectionbitmaps PRIVATE 
        "-I${CMAKE_SOURCE_DIR}/libdwarf")
    target_compile_options(selfsectionbitmaps PRIVATE 
        "-I${CMAKE_BINARY_DIR}/libdwarf")
    add_test(NAME selfsectionbitmaps COMMAND selfsectionbitmaps)
endif()

if (DO_TESTING) 
    set_source_group(SELFPRINTRELOC_SOURCES "Source Files" 
        esb.c print_reloc_test.c)
    add_executable(selfprintreloc ${SELFPRINTRELOC_SOURCES})
    # We need access to a few relocation-data libdwarf headers
    target_compile_options(selfprintreloc PRIVATE ${SELFTEST} )
    target_compile_options(selfprintreloc PRIVATE ${DW_FWALL})
    target_compile_options(selfprintreloc PRIVATE 
        "-I${CMAKE_SOURCE_DIR}/libdwarf")
    target_compile_options(selfprintreloc PRIVATE 
        "-I${CMAKE_BINARY_DIR}/libdwarf")
    add_test(NAME selfprintreloc COMMAND selfprintreloc)
endif()
if (DO_TESTING) 
    set(peobj "${CMAKE_SOURCE_DIR}/dwarfdump/testobjLE32PE.exe") 
    set(pebase "${CMAKE_SOURCE_DIR}/dwarfdump/testobjLE32PE.base") 
    set(execpedd "${CMAKE_BINARY_DIR}/dwarfdump/dwarfdump")
    add_test(NAME selfdwarfdumppe COMMAND sh -c "${execpedd} ${peobj} |  head -500 >junk.testoutpe ; diff ${pebase} junk.testoutpe" )
endif()

if (DO_TESTING) 
    set(elfobj "${CMAKE_SOURCE_DIR}/dwarfdump/testuriLE64ELf.obj") 
    set(elfbase "${CMAKE_SOURCE_DIR}/dwarfdump/testuriLE64ELf.base")
    set(execelfdd "${CMAKE_BINARY_DIR}/dwarfdump/dwarfdump")
    add_test(NAME selfdwarfdumpelf COMMAND sh -c "${execelfdd} ${elfobj} | head -500 > junk.testoutelf ; diff ${elfbase} junk.testoutelf" )
endif()

if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
	set(SUFFIX 64)
endif()
set(LIBDIR lib${SUFFIX})
set(BINDIR bin${SUFFIX})

install(TARGETS dwarfdump DESTINATION
	RUNTIME DESTINATION ${BINDIR}		
	LIBRARY DESTINATION ${LIBDIR}
	ARCHIVE DESTINATION ${LIBDIR})

install(FILES dwarfdump.conf DESTINATION ${LIBDIR})

install(FILES dwarfdump.1 DESTINATION share/man/man1)

=== libdwarf/CMakeLists.txt ===
set_source_group(SOURCES "Source Files" dwarf_abbrev.c 
dwarf_alloc.c dwarf_arange.c 
dwarf_debug_sup.c
dwarf_debuglink.c dwarf_die_deliv.c 
dwarf_debug_names.c dwarf_dsc.c dwarf_elf_access.c 
dwarf_elf_load_headers.c 
dwarf_elfread.c 
dwarf_elf_rel_detector.c 
dwarf_error.c 
dwarf_form.c dwarf_frame.c dwarf_frame2.c dwarf_funcs.c 
dwarf_gdbindex.c dwarf_global.c 
dwarf_gnu_index.c dwarf_groups.c 
dwarf_harmless.c dwarf_generic_init.c dwarf_init_finish.c 
dwarf_leb.c 
dwarf_line.c dwarf_loc.c 
dwarf_loclists.c
dwarf_locationop_read.c
dwarf_machoread.c dwarf_macro.c dwarf_macro5.c
dwarf_names.c
dwarf_object_read_common.c dwarf_object_detector.c
dwarf_original_elf_init.c 
dwarf_peread.c 
dwarf_pubtypes.c dwarf_query.c dwarf_ranges.c 
dwarf_rnglists.c
dwarfstring.h dwarfstring.c
dwarf_stringsection.c
dwarf_tied.c 
dwarf_str_offsets.c
dwarf_tsearchhash.c dwarf_types.c dwarf_util.c 
dwarf_vars.c dwarf_weaks.c dwarf_xu_index.c dwarf_print_lines.c 
malloc_check.c pro_alloc.c pro_arange.c 
pro_debug_sup.c
pro_die.c pro_dnames.c pro_encode_nm.c pro_error.c pro_expr.c 
pro_finish.c pro_forms.c pro_funcs.c pro_frame.c 
pro_init.c pro_line.c pro_reloc.c pro_reloc_stream.c 
pro_reloc_symbolic.c pro_pubnames.c pro_section.c 
pro_types.c pro_vars.c pro_macinfo.c pro_weaks.c)

set_source_group(HEADERS "Header Files" dwarf.h dwarf_abbrev.h
dwarf_alloc.h dwarf_arange.h dwarf_base_types.h 
dwarf_debuglink.h dwarf_die_deliv.h 
dwarf_debug_names.h dwarf_dsc.h 
dwarf_elf_access.h dwarf_elf_defines.h dwarf_elfread.h 
dwarf_elf_rel_detector.h 
dwarf_elf_reloc_386.h dwarf_elf_reloc_aarch64.h 
dwarf_elf_reloc_arm.h dwarf_elf_reloc_mips.h 
dwarf_elf_reloc_ppc64.h 
dwarf_elf_reloc_ppc.h 
dwarf_elf_reloc_sparc.h 
dwarf_elf_reloc_x86_64.h 
dwarf_elfstructs.h 
dwarf_error.h dwarf_frame.h 
dwarf_funcs.h dwarf_gdbindex.h dwarf_global.h dwarf_harmless.h 
dwarf_gnu_index.h 
dwarf_incl.h dwarf_line.h dwarf_loc.h 
dwarf_machoread.h dwarf_macro.h dwarf_macro5.h 
dwarf_names.h
dwarf_object_detector.h dwarf_opaque.h 
dwarf_pe_descr.h dwarf_peread.h
dwarf_reading.h dwarf_reloc_arm.h dwarf_reloc_mips.h 
dwarf_reloc_ppc.h dwarf_reloc_ppc64.h dwarf_reloc_x86_64.h 
dwarf_rnglists.h
dwarf_tied_decls.h 
dwarf_tsearch.h 
dwarf_str_offsets.h
dwarf_types.h dwarf_util.h dwarf_vars.h dwarf_weaks.h 
dwarf_xu_index.h libdwarfdefs.h 
dwarf_macho_loader.h malloc_check.h 
memcpy_swap.h
pro_alloc.h pro_arange.h pro_die.h 
pro_encode_nm.h pro_error.h pro_expr.h pro_frame.h 
pro_incl.h pro_line.h 
pro_log_extra_flag_strings.c
pro_macinfo.h pro_opaque.h 
pro_reloc.h pro_reloc_stream.h pro_reloc_symbolic.h 
pro_section.h pro_types.h pro_util.h)

set_source_group(CONFIGURATION_FILES "Configuration Files" 
    ${CMAKE_SOURCE_DIR}/config.h.in.cmake 
    ${CMAKE_BINARY_DIR}/config.h)


	
list(LENGTH DWARF_TARGETS targetCount)
math(EXPR targetCount "${targetCount} - 1")
foreach(i RANGE ${targetCount})
	list(GET DWARF_TARGETS ${i} target)
	list(GET DWARF_TYPES ${i} type)
	add_library(${target} ${type} ${SOURCES} ${HEADERS}
            ${GENNAMES_OUTPUT} ${CONFIGURATION_FILES})

	set_folder(${target} libdwarf)
	target_include_directories(${target} PUBLIC 
            ${LIBELF_INCLUDE_DIRS})
        target_compile_options(${target} PRIVATE ${DW_FWALL})
	msvc_posix(${target})

	target_link_libraries(${target} PUBLIC ${LIBELF_LIBRARIES})
	
	set_target_properties(${target} PROPERTIES OUTPUT_NAME dwarf)

	set(SUFFIX $<$<EQUAL:${CMAKE_SIZEOF_VOID_P},8>:64>)
	set(LIBDIR lib${SUFFIX})
	set(BINDIR bin${SUFFIX})

	install(TARGETS ${target}
		RUNTIME DESTINATION ${BINDIR}		
		LIBRARY DESTINATION ${LIBDIR}
		ARCHIVE DESTINATION ${LIBDIR})
endforeach()

if(UNIX AND BUILD_SHARED)
	target_link_libraries(dwarf-shared PUBLIC z)
endif()
		
if (DO_TESTING)
    set_source_group(TESTLEB "Source Files" dwarf_leb_test.c 
        dwarf_leb.c pro_encode_nm.c )
    add_executable(selfleb ${TESTLEB})
    target_compile_options(selfleb PRIVATE ${DW_FWALL})
    add_test(NAME selfleb COMMAND selfleb)
endif()
if (DO_TESTING)
    set_source_group(TESTTIED "Source Files" 
        dwarf_tied_test.c dwarf_tied.c dwarf_tsearchhash.c )
    add_executable(selftied ${TESTTIED})
    target_compile_options(selftied PRIVATE ${DW_FWALL})
    add_test(NAME selftied COMMAND selftied)

    set_source_group(TESTSTRING "Source Files" 
        test_dwarfstring.c dwarfstring.c dwarfstring.h)
    add_executable(teststring ${TESTSTRING})
    target_compile_options(selftied PRIVATE ${DW_FWALL})
    add_test(NAME teststring COMMAND teststring)
endif()

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libelf-dev,
                zlib1g-dev
 Standards-Version: 4.5.0
 Homepage: https://www.prevanders.net/dwarf.html
-Vcs-Git: https://salsa.debian.org/wolff-guest/dwarfutils.git/
+Vcs-Git: https://salsa.debian.org/wolff-guest/dwarfutils.git
 Vcs-Browser: https://salsa.debian.org/wolff-guest/dwarfutils
 
 Package: dwarfdump

## dwarfutils 20201201

=== CMakeLists.txt ===
--- 
+++ 
@@ -160,6 +160,13 @@
     NOT HAVE_LIBELF_H AND 
     NOT HAVE_LIBELF_LIBELF_H)
     set(DWARF_WITH_LIBELF OFF)
+    set(HAVE_ELF_H OFF)
+elseif (NOT DWARF_WITH_LIBELF)
+    set(HAVE_ELF_H OFF)
+    set(HAVE_LIBELF_LIBELF_H OFF)
+    set(HAVE_LIBELF_H OFF)
+    set(HAVE_ELF64_GETSHDR OFF)
+    set(HAVE_ELF64_GETEHDR OFF)
 endif ()
 
 if (DWARF_WITH_LIBELF)
@@ -220,6 +227,7 @@
    int i = 12;
    return 0;
   }" HAVE_STRUCT_UNDERSCORE_ELF)
+else()
 endif()
 message(STATUS "Assuming struct Elf for the default libdwarf.h")
 # Because cmake treats ; in an interesting way attempting
@@ -230,11 +238,11 @@
    message(STATUS "Using struct _Elf in libdwarf.h")
    configure_file(libdwarf/generated_libdwarf.h.in 
        libdwarf/libdwarf.h COPYONLY)
-else()
+elseif(NOT DWARF_WITH_LIBELF)
    configure_file(libdwarf/libdwarf.h.in 
        libdwarf/libdwarf.h COPYONLY)
    message(STATUS "${JUST_LIBELF} does not have struct _Elf")
-   message(STATUS "Using struct Elf in libdwarf.h")
+   message(STATUS "Using struct Elf in libdwarf.h, no actual elf.h used")
 endif()
 
 check_c_source_runs("
@@ -301,6 +309,20 @@
       }
       return 0;
   } ]=]  HAVE_ZLIB )
+check_c_source_compiles( [=[
+  #include "zlib.h"
+  int main()
+  {
+      Bytef dest[100];
+      uLongf destlen = 100;
+      Bytef *src = 0;
+      uLong srclen = 3;
+      int res = uncompress(dest,&destlen,src,srclen);
+      if (res == Z_OK) {
+           /* ALL IS WELL */
+      }
+      return 0;
+  } ]=]  HAVE_ZLIB_H )
 set(CMAKE_REQUIRED_LIBRARIES)
 if (HAVE_ZLIB) 
   # For linking in libz
@@ -363,13 +385,3 @@
 option(HAVE_WINDOWS_PATH "Detect certain Windows paths as full paths (default is NO)" FALSE)
 message(STATUS "Checking enable windows path... ${HAVE_WINDOWS_PATH}")
     
-option(HAVE_OLD_FRAME_CFA_COL "Use HAVE_OLD_FRAME_CFA_COL (default is to use new DW_FRAME_CFA_COL3)" FALSE)
-message(STATUS "Checking enable old frame columns... ${HAVE_OLD_FRAME_CFA_COL}")
-
-#  See pro_init(), HAVE_DWARF2_99_EXTENSION also generates
-#  32bit offset dwarf unless DW_DLC_OFFSET_SIZE_64 flag passed to
-#  pro_init.
-option(HAVE_SGI_IRIX_OFFSETS "Force producer to SGI IRIX offset dwarf" FALSE)
-message(STATUS "Checking  producer generates SGI IRIX output... ${HAVE_SGI_IRIX_OFFSETS}")
-
-option(HAVE_STRICT_DWARF2_32BIT_OFFSET "Force producer to generate only DWARF format 32bit" FALSE)

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Build-Depends: debhelper-compat (= 13),
                libelf-dev,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://www.prevanders.net/dwarf.html
-Vcs-Git: https://salsa.debian.org/wolff-guest/dwarfutils.git
-Vcs-Browser: https://salsa.debian.org/wolff-guest/dwarfutils
+Vcs-Git: https://salsa.debian.org/wolff/dwarfutils.git
+Vcs-Browser: https://salsa.debian.org/wolff/dwarfutils
 
 Package: dwarfdump
 Architecture: any

## dwarfutils 20210528

=== libdwarf/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 set_source_group(SOURCES "Source Files" dwarf_abbrev.c 
-dwarf_alloc.c dwarf_arange.c 
+dwarf_alloc.c dwarf_crc32.c dwarf_arange.c 
 dwarf_debug_sup.c
 dwarf_debuglink.c dwarf_die_deliv.c 
 dwarf_debug_names.c dwarf_dsc.c dwarf_elf_access.c 
@@ -7,7 +7,9 @@
 dwarf_elfread.c 
 dwarf_elf_rel_detector.c 
 dwarf_error.c 
-dwarf_form.c dwarf_frame.c dwarf_frame2.c dwarf_funcs.c 
+dwarf_find_sigref.c dwarf_fission_to_cu.c
+dwarf_form.c dwarf_form_class_names.c
+dwarf_frame.c dwarf_frame2.c dwarf_funcs.c 
 dwarf_gdbindex.c dwarf_global.c 
 dwarf_gnu_index.c dwarf_groups.c 
 dwarf_harmless.c dwarf_generic_init.c dwarf_init_finish.c 
@@ -29,6 +31,7 @@
 dwarf_tsearchhash.c dwarf_types.c dwarf_util.c 
 dwarf_vars.c dwarf_weaks.c dwarf_xu_index.c dwarf_print_lines.c 
 malloc_check.c pro_alloc.c pro_arange.c 
+crc32.c
 pro_debug_sup.c
 pro_die.c pro_dnames.c pro_encode_nm.c pro_error.c pro_expr.c 
 pro_finish.c pro_forms.c pro_funcs.c pro_frame.c 
@@ -83,6 +86,10 @@
 	
 list(LENGTH DWARF_TARGETS targetCount)
 math(EXPR targetCount "${targetCount} - 1")
+list(APPEND DWARF_LIBS ${LIBELF_LIBRARIES})
+if(UNIX)
+    list(APPEND DWARF_LIBS z)
+endif()
 foreach(i RANGE ${targetCount})
 	list(GET DWARF_TARGETS ${i} target)
 	list(GET DWARF_TYPES ${i} type)
@@ -109,10 +116,6 @@
 		ARCHIVE DESTINATION ${LIBDIR})
 endforeach()
 
-if(UNIX AND BUILD_SHARED)
-	target_link_libraries(dwarf-shared PUBLIC z)
-endif()
-		
 if (DO_TESTING)
     set_source_group(TESTLEB "Source Files" dwarf_leb_test.c 
         dwarf_leb.c pro_encode_nm.c )
@@ -133,3 +136,25 @@
     target_compile_options(selftied PRIVATE ${DW_FWALL})
     add_test(NAME teststring COMMAND teststring)
 endif()
+# The install has to be here, not in
+# ../CMakeLists.txt  to make install work properly
+# for cmake before cmake 3.13. This also works
+# for newer cmake.
+add_custom_target(dd DEPENDS ${DWARF_TARGETS} dwarfdump)
+install(TARGETS ${DWARF_TARGETS} EXPORT libdwarfTargets
+    ARCHIVE DESTINATION lib
+    LIBRARY DESTINATION lib)
+install(EXPORT libdwarfTargets
+    FILE libdwarf-targets.cmake
+    NAMESPACE libdwarf::
+    DESTINATION lib/cmake/libdwarf
+)
+install(
+    FILES cmake/libdwarf-config.cmake
+    DESTINATION lib/cmake/libdwarf
+)
+install(DIRECTORY libdwarf DESTINATION include/
+    FILES_MATCHING PATTERN "*.h")
+install(
+    FILES ${CMAKE_CURRENT_BINARY_DIR}/libdwarf/libdwarf.h
+    DESTINATION include/libdwarf)

=== tsearch/Makefile ===

EXTRA=-Wsign-compare -Wno-format-y2k -W -Wno-unused-parameter -Wstrict-prototypes -Wmissing-prototypes -Wpointer-arith -Wreturn-type -Wwrite-strings -Wswitch -Wshadow -Wunused-parameter -Wcast-align -Wchar-subscripts -Winline -Wnested-externs  -Wold-style-definition -Wno-pointer-sign 

# -Wcast-qual causes issue. We cast away const with
# respect to create keyptr in places as we will actually eventually
# request (calling code we do not control) that data possibly
# be freed (and hence is changed). 

OPTS= -g -Wall $(EXTRA) -Wextra -Wpointer-arith -Wmissing-declarations -Wcomment -Wformat -Wpedantic -Wuninitialized -Wshadow -Wno-long-long -Wmissing-prototypes -Wdeclaration-after-statement -Wbad-function-cast -Wmissing-parameter-type -Wnested-externs


CC = gcc

HDR=dwarf_tsearch.h config.h
TESTMAIN = tsearch_tester.c 
TS = dwarf_tsearchbin.c 
TSE = dwarf_tsearchepp.c
TSH = dwarf_tsearchhash.c
TSR = dwarf_tsearchred.c
TSB = dwarf_tsearchbal.c
TESTMAINOBJ = tsearch_testerstd.o

all:  binarysearch eppingerdel hashsearch gnusearch redblack balancedsearch


tsearch_testerstd.o: $(TESTMAIN) $(HDR)
	$(CC) $(OPTS) -c  $(TESTMAIN) -o tsearch_testerstd.o

dwarf_tsearchbin.o: $(TS)  $(HDR)
	$(CC) $(OPTS) -c  $(TS) 
binarysearch: dwarf_tsearchbin.o  $(TESTMAINOBJ) $(HDR)
	$(CC) $(OPTS) $(TESTMAINOBJ) dwarf_tsearchbin.o -o binarysearch

dwarf_tsearchbal.o: $(TSB) $(HDR)
	$(CC) $(OPTS) -c  $(TSB)
balancedsearch: dwarf_tsearchbal.o $(TESTMAINOBJ) $(HDR)
	$(CC) $(OPTS) $(TESTMAINOBJ)  dwarf_tsearchbal.o -o balancedsearch

dwarf_tsearchepp.o: $(TSE) $(HDR)
	$(CC) $(OPTS) -c $(TSE) 
eppingerdel: dwarf_tsearchepp.o $(TESTMAINOBJ) $(HDR)
	$(CC) $(OPTS)    $(TESTMAINOBJ) dwarf_tsearchepp.o -o eppingerdel

dwarf_tsearchhash.o: $(TSH) $(HDR)
	$(CC) $(OPTS) -c  $(TSH)
hashsearch: dwarf_tsearchhash.o $(TESTMAIN) $(HDR)
	$(CC) $(OPTS) -DHASHSEARCH -c $(TESTMAIN) -o tsearch_testerhash.o
	$(CC) $(OPTS) tsearch_testerhash.o dwarf_tsearchhash.o -o hashsearch

# Needs a special compile of tsearch_tester.
gnusearch: $(TESTMAINOBJ) $(HDR) $(TESTMAIN)
	$(CC) $(OPTS) -DLIBC_TSEARCH -c $(TESTMAIN) -o tsearch_testergnu.o
	$(CC) $(OPTS) tsearch_testergnu.o -o gnusearch

dwarf_tsearchred.o: $(TSR) $(HDR)
	$(CC) $(OPTS) -c  $(TSR) 
redblack: dwarf_tsearchred.o  $(TESTMAINOBJ) $(HDR)
	$(CC) $(OPTS) $(TESTMAINOBJ)  dwarf_tsearchred.o -o redblack

valgrind:
	valgrind  -v --leak-check=full ./binarysearch
	valgrind  -v --leak-check=full ./eppingerdel
	valgrind  -v --leak-check=full ./hashsearch
	valgrind  -v --leak-check=full ./gnusearch
	valgrind  -v --leak-check=full ./redblack
	valgrind  -v --leak-check=full ./balancedsearch

test: all
	sh RUNTEST

clean:
	rm -f junk*
	rm -f *.o 
	rm -f gnusearch
	rm -f redblack
	rm -f binarysearch
	rm -f simplesearch
	rm -f eppingerdel
	rm -f hashsearch
	rm -f balancedsearch
	rm -f testfail
	rm -f testpass
	rm -f testfailerrs

=== debian/changelog ===
dwarfutils (20210528-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:05:48 +0000

dwarfutils (20210528-1build1) noble; urgency=medium

  * No-change rebuild against libelf1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 00:57:36 +0000

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: dwarfutils
-Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
 Section: libs
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                libelf-dev,
                zlib1g-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://www.prevanders.net/dwarf.html
 Vcs-Git: https://salsa.debian.org/wolff/dwarfutils.git
 Vcs-Browser: https://salsa.debian.org/wolff/dwarfutils

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode
# export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --enable-shared
